datafield.hh File Reference
`#include <cstdio>`
`#include <vector>`
`#include <cmath>`
`#include <cassert>`
`#include <mia/3d/vector.hh>`
`#include <mia/3d/defines3d.hh>`
`#include <mia/3d/iterator.hh>`
`#include <mia/2d/datafield.hh>`
`#include <mia/core/msgstream.hh>`
`#include <mia/core/parameter.hh>`
`#include <mia/core/typedescr.hh>`
`#include <miaconfig.h>`
Include dependency graph for 3d/datafield.hh:
This graph shows which files directly or indirectly include this file:

Go to the source code of this file.

## Data Structures

class | T3DDatafield< T >::ConstRange
class | T3DDatafield< T >::Range
| a shortcut data type More...
class | T3DDatafield< T >
| A templated class of a 3D data field. More...

## Macros

#define | DECLARE_EXTERN(TYPE)
#define | DECLARE_EXTERN_ITERATORS(TYPE)

## Typedefs

typedef T3DDatafield< bool > | C3DBitDatafield
| a data field of float values
typedef CTParameter< C3DBounds > | C3DBoundsParameter
| 3D size parameter type
typedef T3DDatafield< float > | C3DFDatafield
| a data field of float values
typedef CTParameter< C3DFVector > | C3DFVectorParameter
| 3D vector parameter type
typedef TTranslator< C3DFVector > | C3DFVectorTranslator
typedef T3DDatafield< int64_t > | C3DLDatafield
| a data field of 32 bit signed int values
typedef T3DDatafield< int8_t > | C3DSBDatafield
| a data field of 8 bit int values
typedef T3DDatafield< int32_t > | C3DSIDatafield
| a data field of 32 bit signed int values
typedef T3DDatafield< int16_t > | C3DSSDatafield
| a data field of 32 bit signed int values
typedef T3DDatafield< uint8_t > | C3DUBDatafield
| a data field of 8 bit int values
typedef T3DDatafield< uint32_t > | C3DUIDatafield
| a data field of 32 bit unsigned int values
typedef T3DDatafield< uint64_t > | C3DULDatafield
| a data field of 32 bit unsigned int values
typedef T3DDatafield< uint16_t > | C3DUSDatafield
| a data field of 32 bit unsigned int values

## Functions

| DECLARE_EXTERN (C3DDVector)
| DECLARE_EXTERN (C3DFVector)
| DECLARE_EXTERN (double)
| DECLARE_EXTERN (float)
| DECLARE_EXTERN (int16_t)
| DECLARE_EXTERN (int32_t)
| DECLARE_EXTERN (int64_t)
| DECLARE_EXTERN (int8_t)
| DECLARE_EXTERN (uint16_t)
| DECLARE_EXTERN (uint32_t)
| DECLARE_EXTERN (uint64_t)
| DECLARE_EXTERN (uint8_t)
| DECLARE_EXTERN_ITERATORS (bool)
| DECLARE_EXTERN_ITERATORS (double)
| DECLARE_EXTERN_ITERATORS (float)
| DECLARE_EXTERN_ITERATORS (int16_t)
| DECLARE_EXTERN_ITERATORS (int32_t)
| DECLARE_EXTERN_ITERATORS (int64_t)
| DECLARE_EXTERN_ITERATORS (int8_t)
| DECLARE_EXTERN_ITERATORS (uint16_t)
| DECLARE_EXTERN_ITERATORS (uint32_t)
| DECLARE_EXTERN_ITERATORS (uint64_t)
| DECLARE_EXTERN_ITERATORS (uint8_t)

## Variables

template class EXPORT_3D | CTParameter< C3DBounds >
template class EXPORT_3D | CTParameter< C3DFVector >
template class EXPORT_3D | TAttribute< C3DFVector >
template class EXPORT_3D | TTranslator< C3DFVector >

## Macro Definition Documentation

## DECLARE_EXTERN

#define DECLARE_EXTERN | ( |  | TYPE | ) |

Value:
extern template class EXPORT_3D T3DDatafield<TYPE>;
T3DDatafield
A templated class of a 3D data field.
Definition 3d/datafield.hh:83
EXPORT_3D
#define EXPORT_3D
Definition defines3d.hh:45

Definition at line 716 of file 3d/datafield.hh.

## DECLARE_EXTERN_ITERATORS

#define DECLARE_EXTERN_ITERATORS | ( |  | TYPE | ) |

Value:
extern template class EXPORT_3D range3d_iterator<std::vector<TYPE>::iterator>; \
extern template class EXPORT_3D range3d_iterator<std::vector<TYPE>::const_iterator>; \
extern template class EXPORT_3D range3d_iterator_with_boundary_flag<std::vector<TYPE>::iterator>; \
extern template class EXPORT_3D range3d_iterator_with_boundary_flag<std::vector<TYPE>::const_iterator>; \
extern template class EXPORT_3D range2d_iterator<std::vector<TYPE>::iterator>; \
extern template class EXPORT_3D range2d_iterator<std::vector<TYPE>::const_iterator>;
range2d_iterator
Definition 2d/iterator.hh:216
range3d_iterator_with_boundary_flag
a 3D iterator that knows its position in the 3D grid, has a flag indicating whether it is on a bounda...
Definition 3d/iterator.hh:44
range3d_iterator
a 3D iterator that knows its position in the 3D grid ans supports iterating over sub-ranges
Definition 3d/iterator.hh:191

Definition at line 41 of file 3d/datafield.hh.

## Typedef Documentation

## C3DBitDatafield

typedef T3DDatafield<bool> C3DBitDatafield

a data field of float values

Definition at line 573 of file 3d/datafield.hh.

## C3DBoundsParameter

typedef CTParameter<C3DBounds> C3DBoundsParameter

3D size parameter type

Definition at line 576 of file 3d/datafield.hh.

## C3DFDatafield

typedef T3DDatafield<float> C3DFDatafield

a data field of float values

Definition at line 545 of file 3d/datafield.hh.

## C3DFVectorParameter

typedef CTParameter<C3DFVector> C3DFVectorParameter

3D vector parameter type

Definition at line 579 of file 3d/datafield.hh.

## C3DFVectorTranslator

typedef TTranslator<C3DFVector> C3DFVectorTranslator

Definition at line 581 of file 3d/datafield.hh.

## C3DLDatafield

typedef T3DDatafield<int64_t> C3DLDatafield

a data field of 32 bit signed int values

Definition at line 563 of file 3d/datafield.hh.

## C3DSBDatafield

typedef T3DDatafield<int8_t> C3DSBDatafield

a data field of 8 bit int values

Definition at line 569 of file 3d/datafield.hh.

## C3DSIDatafield

typedef T3DDatafield<int32_t> C3DSIDatafield

a data field of 32 bit signed int values

Definition at line 551 of file 3d/datafield.hh.

## C3DSSDatafield

typedef T3DDatafield<int16_t> C3DSSDatafield

a data field of 32 bit signed int values

Definition at line 557 of file 3d/datafield.hh.

## C3DUBDatafield

typedef T3DDatafield<uint8_t> C3DUBDatafield

a data field of 8 bit int values

Definition at line 566 of file 3d/datafield.hh.

## C3DUIDatafield

typedef T3DDatafield<uint32_t> C3DUIDatafield

a data field of 32 bit unsigned int values

Definition at line 548 of file 3d/datafield.hh.

## C3DULDatafield

typedef T3DDatafield<uint64_t> C3DULDatafield

a data field of 32 bit unsigned int values

Definition at line 560 of file 3d/datafield.hh.

## C3DUSDatafield

typedef T3DDatafield<uint16_t> C3DUSDatafield

a data field of 32 bit unsigned int values

Definition at line 554 of file 3d/datafield.hh.

## Function Documentation

## DECLARE_EXTERN() [1/12]

DECLARE_EXTERN | ( | C3DDVector |  | ) |

References EXPORT_3D, and NS_MIA_END.

## DECLARE_EXTERN() [2/12]

DECLARE_EXTERN | ( | C3DFVector |  | ) |

## DECLARE_EXTERN() [3/12]

DECLARE_EXTERN | ( | double |  | ) |

## DECLARE_EXTERN() [4/12]

DECLARE_EXTERN | ( | float |  | ) |

## DECLARE_EXTERN() [5/12]

DECLARE_EXTERN | ( | int16_t |  | ) |

## DECLARE_EXTERN() [6/12]

DECLARE_EXTERN | ( | int32_t |  | ) |

## DECLARE_EXTERN() [7/12]

DECLARE_EXTERN | ( | int64_t |  | ) |

## DECLARE_EXTERN() [8/12]

DECLARE_EXTERN | ( | int8_t |  | ) |

## DECLARE_EXTERN() [9/12]

DECLARE_EXTERN | ( | uint16_t |  | ) |

## DECLARE_EXTERN() [10/12]

DECLARE_EXTERN | ( | uint32_t |  | ) |

## DECLARE_EXTERN() [11/12]

DECLARE_EXTERN | ( | uint64_t |  | ) |

## DECLARE_EXTERN() [12/12]

DECLARE_EXTERN | ( | uint8_t |  | ) |

## DECLARE_EXTERN_ITERATORS() [1/11]

DECLARE_EXTERN_ITERATORS | ( | bool |  | ) |

## DECLARE_EXTERN_ITERATORS() [2/11]

DECLARE_EXTERN_ITERATORS | ( | double |  | ) |

## DECLARE_EXTERN_ITERATORS() [3/11]

DECLARE_EXTERN_ITERATORS | ( | float |  | ) |

## DECLARE_EXTERN_ITERATORS() [4/11]

DECLARE_EXTERN_ITERATORS | ( | int16_t |  | ) |

## DECLARE_EXTERN_ITERATORS() [5/11]

DECLARE_EXTERN_ITERATORS | ( | int32_t |  | ) |

## DECLARE_EXTERN_ITERATORS() [6/11]

DECLARE_EXTERN_ITERATORS | ( | int64_t |  | ) |

## DECLARE_EXTERN_ITERATORS() [7/11]

DECLARE_EXTERN_ITERATORS | ( | int8_t |  | ) |

## DECLARE_EXTERN_ITERATORS() [8/11]

DECLARE_EXTERN_ITERATORS | ( | uint16_t |  | ) |

## DECLARE_EXTERN_ITERATORS() [9/11]

DECLARE_EXTERN_ITERATORS | ( | uint32_t |  | ) |

## DECLARE_EXTERN_ITERATORS() [10/11]

DECLARE_EXTERN_ITERATORS | ( | uint64_t |  | ) |

## DECLARE_EXTERN_ITERATORS() [11/11]

DECLARE_EXTERN_ITERATORS | ( | uint8_t |  | ) |

## Variable Documentation

## CTParameter< C3DBounds >

template class EXPORT_3D CTParameter< C3DBounds >

extern

## CTParameter< C3DFVector >

template class EXPORT_3D CTParameter< C3DFVector >

extern

## TAttribute< C3DFVector >

template class EXPORT_3D TAttribute< C3DFVector >

extern

## TTranslator< C3DFVector >

template class EXPORT_3D TTranslator< C3DFVector >

extern